/*
 * cit86exp.c
 * v3.1
 *
 * See copyright.doc for copyright information
 *
 */

#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <time.h>

char *html_to_ascii(char *inputmsg, int screenwidth, int do_citaformat);

#define DEFAULT_GDOM	"IGnet"

/* Need an unsigned type capable of holding 32 bits; */
typedef unsigned long int UNS_32_BITS;

struct sbt {
	struct sbt *next;
	char sbt_small[16];
	char sbt_big[64];
	char sbt_phone[64];
	char sbt_gdom[64];
};

char *malloc();
long atol();
struct sbt *sbt;

char *monthdesc[] =
{"Jan", "Feb", "Mar", "Apr", "May", "Jun",
 "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};


int getstring(str, fp)
char str[];
FILE *fp;
{
	int len = 0;
	int ch;
	while (ch = getc(fp), ch > 0)
		str[len++] = ch;
	str[len] = 0;
	return (len);
}

int conv_24_12(i24)
int i24;
{
	if (i24 == 0)
		return (12);
	if (i24 < 13)
		return (i24);
	return (i24 - 12);
}

int main(int argc, char **argv)
{

	char buf[256], buf2[256];
	char tempfilename[32];
	char roomname[20];
	char destsys[20];
	char phonenum[32];
	char gdom[32];
	FILE *fp;
	int a, b, c;
	long timebuf;
	struct tm *ltime;
	long idbuf;
	int mtype = 0;
	int mmode = 0;
	char *mtext = NULL;
	size_t mtext_msglen = 0;
	size_t mtext_buflen = 0;
	char content_type[1024];
	char *degraded_text = NULL;

	if (argc != 2) {
		fprintf(stderr, "%s: usage: %s neighbor_node\n",
			argv[0], argv[0]);
		exit(1);
	}

	sprintf(tempfilename, "/tmp/cit86.%d", getpid());

	while (!feof(stdin)) {
		/* seek to the next message */
		do {
			a = getc(stdin);
		} while ((a != 255) && (!feof(stdin)));
		if (feof(stdin))
			exit(0);
		mtype = getc(stdin);
		mmode = getc(stdin);

		strcpy(roomname, "");
		strcpy(destsys, "");
		time(&idbuf);
		while (a = getc(stdin), ((a != 'M') && (!feof(stdin)))) {
			getstring(buf, stdin);
			if (a == 'A') {
				printf("A%s%c", buf, 0);
			}
			if (a == 'R') {
				printf("T%s%c", buf, 0);
			}
			if (a == 'N') {
				printf("O%s%c", buf, 0);
			}
			if (a == 'H') {
				printf("N%s%c", buf, 0);
				printf("X%s%c", DEFAULT_GDOM, 0);
			}
			if (a == 'D') { /* this probably won't work */
				strcpy(destsys, buf);
				printf("t%s%c", buf2, 0);
			}
			if (a == 'O') {
				if (strlen(roomname) == 0) {
					strcpy(roomname, buf);
				}
			}

			if (a == 'C') {
				strcpy(roomname, buf);
			}

			if (a == 'T') {
				timebuf = atol(buf);
				ltime = (struct tm *) localtime(&timebuf);
				printf("D%02d%3s%02d%c",
					(ltime->tm_year % 100),
					monthdesc[ltime->tm_mon],
					ltime->tm_mday, 0);
				printf("C%02d:%02d %2s%c",
					conv_24_12(ltime->tm_hour),
					ltime->tm_min,
				   ((ltime->tm_hour < 13) ? "am" : "pm"),
					0);
			}

			if (a == 'I') {
				idbuf = atol(buf);
				printf("S%ld %ld%c",
					((idbuf & 0xFFFF0000) >> 16),
					(idbuf & 0x0000FFFF),
					0);
			}
		}

		if (feof(stdin)) {
			exit(0);
		}

		printf("R%s%c", roomname, 0);

		/* Translate the message text from IGnet to Cit86Net format */
		printf("M");
		mtext = strdup("");
		mtext_msglen = 0;
		mtext_buflen = 0;

		while (a = getc(stdin), a > 0) {
			if (mtext_buflen - mtext_msglen < 100) {
				mtext_buflen += 8192;
				mtext = realloc(mtext, mtext_buflen);
			}

			/* Make sure pull quotes are indented at least one
			 * space, otherwise they look like garbage, because
			 * Cit86Net doesn't support fixed-format messages
			 */
			if (mtext_msglen > 0)
			   if (mtext[mtext_msglen-1] == 10)
			      if (a == '>') {
				mtext[mtext_msglen] = ' ';
				mtext[++mtext_msglen] = 0;
				
			}

			/*
			 * Now append the new character
			 */
			mtext[mtext_msglen] = a;
			mtext[++mtext_msglen] = 0;
		}

		striplt(mtext);
		if (mtext[strlen(mtext)-1] == 10) {
			mtext[strlen(mtext)-1] = 0;
		}

		/* Degrade the format if necessary */
		if (mmode == 4) {
			do {
				if (!strncasecmp(mtext, "Content-type: ", 14)) {
					extract_token(content_type, mtext, 0, '\n');
					strcpy(content_type, &content_type[14]);
					striplt(content_type);
				}
				remove_token(mtext, 0, '\n');
			} while ((mtext[0] != 0) && (mtext[0] != '\n'));
			if (!strcasecmp(content_type, "text/html")) {
				degraded_text = html_to_ascii(mtext, 80, 1);
				free(mtext);
				mtext = degraded_text;
			}
		}

		/* Now output it */
		printf("%s%c", mtext, 0);
		free(mtext);

	}
	return (0);
}
