/*
 * cit86imp.c  -  import Cit86Net messages into Citadel/UX
 * version 2.3
 */

#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <ctype.h>

#define SIZ 4096

time_t conv86date(char *, char *);

void bigtosmall(char *smallname, char *bigname) {
 
	int a;
	struct syslist *stemp;

	strcpy(smallname, bigname);

	for (a = 0; a < strlen(smallname); ++a) {
		smallname[a] = tolower(smallname[a]);
	}

	if (!strncmp(smallname, "the ", 4)) {
		strcpy(smallname, &smallname[4]);
	}

	for (a = 0; a < strlen(smallname); ++a) {
		if (!isalpha(smallname[a])) {
			strcpy(&smallname[a], &smallname[a + 1]);
			a = 0;
		}
	}

	smallname[8] = 0;
}


int getstring(str, fp)
char str[];
FILE *fp;
{
	int len = 0;
	int ch;
	while (ch = getc(fp), ch > 0) {
		str[len++] = ch;
	}
	str[len] = 0;
	return (len);
}

int main(argc, argv)
int argc;
char *argv[];
{
	char buf[SIZ];
	char holdbuf[SIZ];
	char author[SIZ];
	char datestamp[SIZ];
	char timestamp[SIZ];
	char path[SIZ];
	char orignode[SIZ];
	char destnode[SIZ];
	char recipient[SIZ];
	char bigname[SIZ];
	char room[SIZ];
	char current_room[SIZ];
	char phonenum[SIZ];
	char domain[SIZ];
	long message_id;
	long id1, id2;
	int a, b;

	if (argc != 3) {
		fprintf(stderr, "%s: usage: %s <neighbor_node <my_node>\n",
			argv[0], argv[0]);
		exit(1);
	}

	strcpy(current_room, "");
	for (a = 3; a < argc; ++a) {
		strcat(current_room, argv[a]);
		if (a < (argc - 1))
			strcat(current_room, " ");
	}

	while (!feof(stdin)) {
		strcpy(orignode, argv[1]);
		strcpy(bigname, argv[1]);
		strcpy(destnode, "");
		strcpy(author, "");
		strcpy(recipient, "");
		strcpy(room, current_room);
		strcpy(domain, "");
		message_id = time(NULL);
		strcpy(datestamp, "");
		strcpy(timestamp, "");

		while (a = getc(stdin), ((a != 'M') && (!feof(stdin)))) {
			if (feof(stdin)) {
				exit(0);
			}

			/* We no longer set the destination node to our own
			 * by default.  Better to leave it blank, otherwise it
			 * screws up propagation.
			 * strcpy(destnode, argv[2]); */

			getstring(buf, stdin);
			if (a == 'A') {
				strcpy(author, buf);
			}
			if (a == 'N') {
				strcpy(bigname, buf);
				bigtosmall(orignode, buf);
			}
			if (a == 'T') {
				strcpy(recipient, buf);
			}
			if (a == 't') {
				bigtosmall(destnode, buf);
			}
			if (a == 'R') {
				strcpy(room, buf);
				strcpy(current_room, buf);
			}
			if (a == 'S') {
				sscanf(buf, "%ld %ld", &id1, &id2);
				id1 = id1 << 16L;
				message_id = id1 + id2;
			}
			if (a == 'D') {
				strcpy(datestamp, buf);
			}
			if (a == 'C') {
				strcpy(timestamp, buf);
			}
		}
		if (feof(stdin)) {
			exit(0);
		}

		strcpy(path, "");
		if (strcmp(orignode, argv[1])) {
			strcat(path, argv[1]);
			strcat(path, "!");
		}

		strcat(path, orignode);
		strcat(path, "!");
		strcat(path, author);
		for (b = 0; b < strlen(path); ++b) {
			path[b] = tolower(path[b]);
			if (path[b] == 32)
				path[b] = '_';
		}

/* if the room name is not "Mail" we clobber any recipient name that happens
 * to be there.  This is because some C86Net systems have people posting to
 * them using QWK readers, which generate "To" fields...
 */
		if (strcasecmp(room, "Mail")) {
			strcpy(recipient, "");
		}

/* now generate a message in Citadel/UX format. */
		putc(255, stdout);
		printf("A");
		putc(0, stdout);	/* non-anon & formatted */
		printf("P%s", path);
		putc(0, stdout);
		printf("I%ld@%s", message_id, orignode);
		putc(0, stdout);
		printf("T%ld", conv86date(datestamp, timestamp));
		putc(0, stdout);
		printf("A%s", author);
		putc(0, stdout);
		printf("O%s", room);
		putc(0, stdout);
		printf("C%s", current_room);
		putc(0, stdout);
		printf("N%s", orignode);
		putc(0, stdout);
		printf("H%s", bigname);
		putc(0, stdout);
		if (strlen(recipient) > 0) {
			printf("R%s", recipient);
			putc(0, stdout);
		}
		if (strlen(destnode) > 0) {
			printf("D%s", destnode);
			putc(0, stdout);
		}
		printf("M");
		while (a = getc(stdin), a > 0) {
			putc(a, stdout);
			b = a;
		}
		if (b != 10) {
			putc(10, stdout);
		}
		putc(0, stdout);
	}
}
