/*
 * conv86date.c
 *
 * Function to convert Cit86Net format date and time stamps to Unix time_t
 *
 */

#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <ctype.h>
#include <time.h>

static char *monthdesc[] = {
	"Jan", "Feb", "Mar", "Apr", "May", "Jun",
	"Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
};

time_t conv86date(char *datestamp, char *timestamp)
{

	struct tm *ltime;
	time_t now;
	int i;

	now = time(NULL);
	ltime = localtime(&now);

	if (strlen(datestamp) == 7) {
		ltime->tm_year = atoi(&datestamp[0]) + 100;
		ltime->tm_mday = atoi(&datestamp[5]);

		for (i = 0; i < 12; ++i) {
			if (!strncasecmp(&datestamp[2], monthdesc[i], 3)) {
				ltime->tm_mon = i;
			}
		}
	}
	if (strlen(timestamp) > 0) {

		ltime->tm_hour = 0;
		ltime->tm_min = 0;
		ltime->tm_sec = 0;

		for (i = 0; i < strlen(timestamp); ++i) {
			if (timestamp[i] == ':') {
				ltime->tm_hour = atoi(timestamp);
				ltime->tm_min = atoi(&timestamp[i + 1]);
			} else if (timestamp[i] == 'a') {
				if (ltime->tm_hour == 12) {
					ltime->tm_hour = 0;
				}
			} else if (timestamp[i] == 'p') {
				if (ltime->tm_hour < 12) {
					ltime->tm_hour += 12;
				}
			}
		}

	}
	return (time_t) mktime(ltime);
}
